<template>
  <AbsoluteLayout ref="absolute" width="100%" >
    <TextField 
      class="search-bar"
      ref="searchBar"
      v-model="searchQuery"
      width="100%"
      opacity="0.7"
      hint="What are you looking for?"
      :visibility="isVisible"
      returnKeyType="go"
      @returnPress="onSearchPress"
      />
  </AbsoluteLayout>
</template>

<script>
import axios from 'axios/dist/axios'
export default {
  props: {
    visible: {
      default: false
    }
  },
  data() {
    return {
      searchQuery: ''
    }
  },

  computed: {
    isVisible: function() {
      if (!this.visible) {
        this.onSearchPress()
      }
      return this.visible ? "visible" : "collapsed";
    }
  },

  methods: {
    onSearchPress: async function () {
      //TODO: Set user store and update user instance in firebase to contain the latest map center point!
      // Commit this information to the user state
      // Add the following login to a state action.
      // if (this.searchQuery !== '' && this.searchQuery.length > 4) {
      //   const geocodingUrl = `https://api.mapbox.com/geocoding/v5/mapbox.places/${this.searchQuery}.json?limit=2&access_token=${this.$mapboxAccessToken}`
      //   try {
      //     const { data } = await axios.get(geocodingUrl)
      //     if (data.hasOwnProperty('features')) {
      //       this.$emit('centerCoordinates', data.features[0].center)
      //     }
      //   } catch (error) {
      //     console.log(error)
      //     throw error
      //   }
      //   this.toggleSearchBar()
      //   this.searchQuery = ''
      // }

    },
    toggleSearchBar() {
      this.visible = !this.visible
    }
  }
};
</script>

<style scoped>
.search-bar {
  background-color: white;
}
</style>